#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <stl.h>
#include <string>
#include <strstream>
#include <stl_queue.h>

//#define DEB

#ifdef DEB
#define DEBUGN(x) cerr << x
#define DEBUG(x) cerr << x << endl
#else
#define DEBUG(x)
#define DEBUGN(x)
#endif

#define INPUT_FILE "erdos.in"
#define PI (3.14159265359)

#define TRUE (0==0)
#define FALSE !TRUE

#define MAXINT (1<<30)
#define MININT -MAXINT

#define min(x,y) ((x<y)?x:y))
#define max(x,y) ((x>y)?x:y))

ifstream foo(INPUT_FILE);
istream &in = foo;

ostream& out=cout;

string    names[20001];
vector<int> adj[20001];

int nanz;

int findnadd(string n) {
  for (int i=0;i<nanz;i++) {
		if (names[i]==n) return i;
  }
	names[nanz]=n;
	adj[nanz].clear();
	nanz++;
	return nanz-1;
}

void addedge(string a, string b) {
	int n1=findnadd(a);
	int n2=findnadd(b);
	adj[n1].push_back(n2);
	adj[n2].push_back(n1);
	DEBUG("addedge: " << a << " " << b << " " << n1 << " " << n2);
}

int dist[20001];
int findme[20001];
vector<int> tofind;
int anz=0, fanz;

void search() {

  bzero(dist,sizeof(dist));

	int s = findnadd("Erdos, P.");

	dist[s]=1;

	queue<int> todo;
	todo.push(s);
	while (!todo.empty()) {
		int n=todo.front();
		DEBUG(n);
		if (findme[n]) {
			fanz--;
			if (fanz==0) return;
			}
		todo.pop();
		vector<int>::iterator it=adj[n].begin();
	  while (it!=adj[n].end()) {
      int m=*it;
			DEBUG ("neigh: " << m<< " " << dist[m]);
			if (dist[m]==0) {
			  dist[m]=dist[n]+1;
				todo.push(m);
		  }
	    it++;
    }
	}

}

//long long int bla;

int main(char **argv, int argc) {
  int num=0;
	int p,n;
  in >> p >> n >> ws;
  while (p>0) {
	 nanz=0;
    for (int e=0;e<p;e++) {
			char s[300];
      in.getline(s,sizeof(s)-1);
   		istrstream i(s);
			char f[300],l[300];
		  bzero(f,sizeof(f)-1);
		  bzero(l,sizeof(l)-1);
			i >> f >> l;
			int c=0;
			string ls[300];
			while (l[strlen(l)-1] != ':') {
				l[strlen(l)-1] =0;
				string n = string(f)+" "+string(l);
				ls[c]=n;
				for (int j=0;j<c;j++) {
				  addedge(ls[j],n);
					}
				c++;
			  bzero(f,sizeof(f)-1);
			  bzero(l,sizeof(l)-1);
				i >> f >> l;
			}
			l[strlen(l)-1] =0;
			string n = string(f)+" "+string(l);
			ls[c]=n;
			for (int j=0;j<c;j++) {
			  addedge(ls[j],n);
			}
    }
    out << "Database #" << ++num << endl;

		tofind.clear();
		fanz=0;
		bzero(findme,sizeof(findme));

	  for (int e=0;e<n;e++) {
		  char s[300];
			in.getline(s,sizeof(s)-1);
			if (s[strlen(s)-1]=='\n') s[strlen(s)-1]=0;
			int x = findnadd(s);
		  findme[x]=1;
			fanz++;
			tofind.push_back(x);
    }

	  search();

		vector<int>::iterator it=tofind.begin();
	  while (it!=tofind.end()) {
		  int n = *it;
		  out << names[n] << ": ";
			if (dist[n]>0) {
  			out << dist[n]-1 << endl;
			} else {
				out << "infinity" << endl;
			}
		  it++;
		}

    in >> p >> n >> ws;
  }
	return 0;
}




