#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <stl.h>
#include <stl_queue.h>
#include <string>
#include <strstream>

//#define DEB

#ifdef DEB
#define DEBUGN(x) cerr << x
#define DEBUG(x) cerr << x << endl
#else
#define DEBUG(x)
#define DEBUGN(x)
#endif

#define INPUT_FILE "railroad.in"
#define PI (3.14159265359)

#define TRUE (0==0)
#define FALSE !TRUE

#define MAXINT (1<<30)
#define MININT -MAXINT

#define min(x,y) ((x<y)?x:y))
#define max(x,y) ((x>y)?x:y))

ifstream foo(INPUT_FILE);
istream &in = foo;

ostream& out=cout;

class connection {
	public:
	int departure;
	int arrival;
	string city;
};

bool operator < (const connection& a, const connection& b) {
	return (a.departure < b.departure);	
}

class city {
	public:
	string name;
	int departure;
	int time;
	list<connection> connections;
	city* last;
};

bool operator < (const city& a, const city& b) {
	return (a.time < b.time);	
}

class city_rep {
	public:
	city* p;
	city_rep(city* c) {
		p = c;
	}
};

bool operator < (const city_rep& a, const city_rep& b) {
	return (a.p->time > b.p->time);	
}

map<string, city*> cities;

int scenario;
int cities_count;
int train_count;
int stops_count;

int earliest_dep;
string start;
string end;


int read_time() {
	char c; int time=0;
	in >> c;
	c -= '0';
	time += c*60*10;
	in >> c;
	c -= '0';
	time += c*60;
	in >> c;
	c -= '0';
	time += c*10;	
	in >> c;
	c -= '0';
	time += c;
	return time;
}


void expand(city* curr, priority_queue<city_rep>& queue) {
		list<connection>::iterator it = curr->connections.begin();
		list<connection>::iterator it2 = curr->connections.end();
		DEBUG("Expanding " << curr->name);
		while (it != it2) {
		DEBUG("  examinining conn to " << it->city);
			if (it->departure >= curr->time) {
				map<string, city*>::iterator cit = cities.find(it->city);
				city* c = cit->second;
				if (c->time > it->arrival) {
					DEBUG("  put into queue, shorter time " << it->arrival );
					c->last = curr;
					c->time = it->arrival;
					c->departure = it->departure;
					queue.push(*(new city_rep(c)));
				}
				if (c->time == it->arrival && c->departure < it->departure) {
					DEBUG("  put into queue, better departure");
					c->last = curr;
					c->time = it->arrival;
					c->departure = it->departure;
					queue.push(*(new city_rep(c)));
				}
			}
			it++;
		}
}


void simulate() {
	priority_queue<city_rep> queue;
	map<string, city*>::iterator cit = cities.find(start);	
	cit->second->time = earliest_dep;
	queue.push(*(new city_rep(cit->second)));

	while(TRUE) {
		if (queue.empty()) break;
		city_rep curr = queue.top();
		queue.pop();
		if (curr.p->name == end) break;
		expand(curr.p, queue);
	}
}

void print_time(int time) {
	int tmp;
	tmp = time / (60*10);
	out.put(tmp+'0');
	time -= tmp*60*10;
	tmp = time / (60);
	out.put(tmp+'0');
	time -= tmp*60;
	tmp = time / (10);
	out.put(tmp+'0');
	time -= tmp*10;
	tmp = time;
	out.put(tmp+'0');
}

void output() {
	int departure, arrival;
	map<string, city*>::iterator it = cities.find(end);
	city* c = it->second;
	arrival = c->time;
	if (arrival == MAXINT) {
		out << "No connection" << endl;
		return;
	}
	while (c->last->name != start) {
		c = c->last;
	}
	departure = c->departure;
	out << "Departure ";
	print_time(departure);
	out << " " << start << endl;
	out << "Arrival   ";
	print_time(arrival);
	out << " " << end << endl;
	
}


int main(char **argv, int argc) {
	string str, from, to;
	city* cy;
	int dep;
	connection* conn;

	while(TRUE) {
		scenario++;
		cities.clear();
		in >> cities_count;
		DEBUG("Cities max size: " << cities.max_size());
		DEBUG("Cities: " << cities_count);
		if (cities_count == 0) break;
		out << "Scenario #" << scenario << endl;

		for (int i=0; i< cities_count; i++) {
			in >> str;
			cy = new city;
			cy->name = str;
			cy->departure = 0;
			cy->time=MAXINT;
			cities.insert(*(new pair<string, city*>(str, cy)));
			DEBUG(cy->name);
		}

		in >> train_count;
		DEBUG("Trains: " << train_count);
		for (int i=0; i<train_count; i++) {
			in >> stops_count;
			if (stops_count == 0) continue;
			if (stops_count == 1) {
				read_time();
				in >> str;
				in >> ws;
				continue;
			}
			int arr = read_time();
			in >> ws;
			in >> to;
			in >> ws;
			for (int j=1; j<stops_count; j++) {
				dep = arr;
				from = to;
				int arr = read_time();
				in >> ws;
				in >> to;
				in >> ws;
				conn = new connection;
				conn->departure=dep;
				conn->arrival=arr;
				conn->city=to;
				DEBUG(from << ":" << conn->departure << "->" << conn->city << ":" << conn->arrival);
				map<string, city*>::iterator it = cities.find(from);
				it->second->connections.push_front(*conn);
				DEBUG(it->second->connections.size());
			}
		}
		earliest_dep = read_time();
		in >> start;
		in >> end;
		DEBUG(start << ":" << earliest_dep << "->" << end);
		simulate();
		output();
		out << endl;
	}
	return 0;
}

